# -*- coding: utf-8 -*-
"""
/***************************************************************************
 Heightmap Export
 -------------------
 Release Date: 2019-01-24
 Nathaniel Klumb
 Email: heightmap@clayjar.com
 git SHA: $Format:%H$
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""
from PyQt4.QtCore import QSettings, QTranslator, qVersion, QCoreApplication
from PyQt4.QtGui import QAction, QIcon, QMessageBox
# Initialize Qt resources from file resources.py
import resources_rc
# Import the code for the dialog
from HeightmapExport_Dialog import HeightmapExportDialog
#import HeightmapExportDialog
#import os.path

class HeightmapExport:
    """QGIS Plugin Implementation."""

    def __init__(self, iface):
        """Constructor.

        :param iface: An interface instance that will be passed to this class
            which provides the hook by which you can manipulate the QGIS
            application at run time.
        :type iface: QgsInterface
        """
        # Save reference to the QGIS interface
        self.iface = iface
        # initialize plugin directory
        #self.plugin_dir = os.path.dirname(__file__)
        # initialize locale
        #locale = QSettings().value('locale/userLocale')[0:2]
        #locale_path = os.path.join(
        #    self.plugin_dir,
        #    'i18n',
        #    'DEMtoPNG_{}.qm'.format(locale))

        #if os.path.exists(locale_path):
        #    self.translator = QTranslator()
        #    self.translator.load(locale_path)

        #    if qVersion() > '4.3.3':
        #        QCoreApplication.installTranslator(self.translator)

        # Declare instance attributes
        self.action = None
        self.menu = '&Heightmap Export'

        self.window = True

    # noinspection PyMethodMayBeStatic
    #def tr(self, message):
     #   """Get the translation for a string using Qt translation API.
     #
     #   We implement this ourselves since we do not inherit QObject.
     #
     #   :param message: String for translation.
     #   :type message: str, QString
     #
     #   :returns: Translated version of message.
     #   :rtype: QString
     #   """
     #   # noinspection PyTypeChecker,PyArgumentList,PyCallByClass
     #   return QCoreApplication.translate('DEMtoPNG', message)

    def initGui(self):
        """Create the menu entries and toolbar icons inside the QGIS GUI."""
        icon = QIcon(":/plugins/HeightmapExport/HeightmapExport.png")
        parent = self.iface.mainWindow()
        self.action = QAction(icon, "Heightmap Export", parent)
        self.action.setObjectName("Heightmap Export")
        self.action.setStatusTip("Export 16-bit PNG heightmaps")
        self.action.triggered.connect(self.run)

        self.iface.addPluginToRasterMenu(self.menu, self.action)
        self.iface.addRasterToolBarIcon(self.action)
        
    def unload(self):
        """Removes the plugin menu item and icon from QGIS GUI."""
        self.iface.removePluginRasterMenu(self.menu, self.action)
        self.iface.removeRasterToolBarIcon(self.action)

    def run(self):
        hmexport = HeightmapExportDialog(self.iface)
        hmexport.exec_()
        if hmexport.extent:
            self.iface.mapCanvas().scene().removeItem(hmexport.extent)
            #canvas = self.iface.mapCanvas()
            #canvas.scene().removeItem(hmexport.extent)
        #layers = self.iface.legendInterface().layers()
        #raster = False
        #if layers:
        #    for layer in layers:
        #        if layer.type() == 1 and self.iface.legendInterface().isLayerVisible(layer):
        #            raster = True
        #            break
        #    if raster and self.window:
        #        self.window = False
        #        demtopng_dlg = DEMtoPNG_dialog.DEMtoPNGDialog(self.iface)
        #        demtopng_dlg.exec_()
        #        if demtopng_dlg.extent:
        #            canvas = self.iface.mapCanvas()
        #            canvas.scene().removeItem(demtopng_dlg.extent)
        #        self.window = True
        #    elif not raster:
        #        QMessageBox.information(self.iface.mainWindow(), "DEMtoPNG", self.tr("No visible raster layer loaded"))
        #elif not layers:
        #    QMessageBox.information(self.iface.mainWindow(), "DEMtoPNG", self.tr("No layer loaded"))
